const Mesa = require('vendor/Mesa.js');

/**
 * A Mesa Script exports a class with a script() method.
 */
module.exports = new class {

  /**
   * Mesa Script
   *
   * @param {object} payload The payload data
   * @param {object} context Additional context about this task
   */
  script = (payload, context) => {
    const vars = context.steps;

    let priceHistory = JSON.parse(vars.shopify_1.value);
    let newPricePointId = vars.custom.price_point.id;

    priceHistory.unshift(newPricePointId);

    Mesa.output.next({"new_price_history": priceHistory});
  }
}
