const Mesa = require('vendor/Mesa.js');
const ShopifyGraphql = require('vendor/ShopifyGraphql.js');
const Shopify= require('vendor/Shopify.js');

/**
 * A Mesa Script exports a class with a script() method.
 */
module.exports = new class {
  script = (payload, context) => {
    let vars = context.steps;
    
    let query = `
      mutation metafieldsSet($metafields: [MetafieldsSetInput!]!) {
        metafieldsSet(metafields: $metafields) {
          metafields {
            key
            namespace
            value
            createdAt
            updatedAt
          }
          userErrors {
            field
            message
            code
          }
        }
      }
    `;

    const r = ShopifyGraphql.send(query, {
      "metafields" : [
        {
        "namespace": "custom",
        "key": "price_history",
        "type": "list.metaobject_reference",
        "value": JSON.stringify(vars.custom_1.new_price_history),
        "ownerId": "gid://shopify/Product/8439934910785",
        }
      ]
    }, {}, 'admin/api/2023-10/graphql.json');

    if (r.data.metafieldsSet.userErrors.length) {
      throw new Error(JSON.stringify(r.data.metafieldsSet.userErrors));
    }

    Mesa.output.next({"result": r.data});
  }
}